var splash = document.getElementById('splash');
var loadingScreen = document.getElementById('loading');
var appScreen = document.getElementById('app');

var canvas;
var context;
var pictureProperties;
var image = new Image();
var seal = new Image(); seal.src = 'img/layout/borda-img-out-rosa.png';
var maxSize = 1000;
var xDest = 0;
var yDest = 0;
var platform;

var app = {
  // Application Constructor
  initialize: function() {
    'use strict';
    this.bindEvents();
  },
  // Bind Event Listeners
  //
  // Bind any events that are required on startup. Common events are:
  // 'load', 'deviceready', 'offline', and 'online'.
  bindEvents: function() {
    'use strict';
    document.addEventListener('deviceready', this.onDeviceReady, false);
  },
  onDeviceReady: function() {
    'use strict';
    
    window.setTimeout(function(){
        splash.className = 'out';            
    }, 2000);
    window.setTimeout(function(){
        splash.style.display = 'none';
        appScreen.className = '';

    }, 3000);

    platform = device.platform;
    platform = platform.toLowerCase();

    pictureProperties = {
                quality : 50, 
                destinationType : Camera.DestinationType.FILE_URI,
                sourceType : Camera.PictureSourceType.CAMERA, 
                allowEdit : false,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 2000,
                targetHeight: 2000,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: true
              };

    if (platform == 'android') {
      pictureProperties.quality = 100;
    }

  }
};

var showLoading = function() {
  'use strict';

  appScreen.className = 'out';    
  window.setTimeout(function(){
      loadingScreen.style.display = 'block';
      loadingScreen.className = '';
  }, 1000);
  return false;
};

var hideLoading = function() {
  'use strict';

  loadingScreen.className = 'out';    
  window.setTimeout(function(){
      loadingScreen.style.display = 'none';
      appScreen.className = '';
  }, 1000);
  return false;
};

var btnCamera = function() {
  showLoading();
  var myProperties = pictureProperties;
  myProperties.sourceType = Camera.PictureSourceType.CAMERA;
  navigator.camera.getPicture(onSuccessGetPicture, onFailGetPicture, myProperties);
};

var btnGaleria = function() {
  showLoading();
  var myProperties = pictureProperties;
  myProperties.sourceType = Camera.PictureSourceType.SAVEDPHOTOALBUM;
  navigator.camera.getPicture(onSuccessGetPicture, onFailGetPicture, myProperties);
};

var onSuccessGetPicture = function(imageData) {
  canvas = document.getElementById('photo');
  context = canvas.getContext('2d');
  drawImage(imageData);
};

var onFailGetPicture = function(message) {
    // Camera not complete
    hideLoading();
};

var drawImage = function(imageData) {
  xDest = 0;
  yDest = 0;
  image = new Image();
  image.onload = function() {
    // Redimensionando Imagem
    if (image.width < image.height) {
      if(image.width > maxSize) {
        image.height *= maxSize / image.width;
        image.width = maxSize;
      }
      yDest = ((image.height - maxSize) / 2) * (-1);
    } else {
      if(image.height > maxSize) {
        image.width *= maxSize / image.height;
        image.height = maxSize;
      }
      xDest = ((image.width - maxSize) / 2) * (-1);
    }

    // Limpando o Canvas
    context.clearRect(0, 0, canvas.width, canvas.height);
  
    // Preenchendo o Canvas com a Imagem
    context.drawImage(image, xDest, yDest, image.width, image.height);

    // Aplicando dessaturização
    Pixastic.process(document.getElementById("photo"), "desaturate", {average : false});

    // Aplicando efeito rosa
    Pixastic.process(document.getElementById("photo"), "blend", {
      amount : 1,
      mode : 'overlay',
      image : document.getElementById("filter")
    });

    // Aplicando selo Tacaruna
    Pixastic.process(document.getElementById("photo"), "blend", {
      amount : 1,
      mode : 'normal',
      image : seal
    });

    // Share Instagram (setTimeout é o hack para iOS)
    setTimeout(shareInstagram,1200);
  };

  image.src = imageData;
};

var shareInstagram = function() {
  Instagram.isInstalled(function (err, installed) {
    if (installed) {
      Instagram.share('photo', 'Eu apoio o #outubrorosa @shoppingtacaruna', function (err) {
        // Gerando LOG de geração de foto
        var xmlhttp=new XMLHttpRequest();
        xmlhttp.open('POST', 'http://shoppingtacaruna.com.br/outubrorosaregister');
        xmlhttp.setRequestHeader('Content-type','application/x-www-form-urlencoded');
        xmlhttp.onreadystatechange=function(){};
        xmlhttp.send('platform='+device.platform+'&model='+device.model+'&version='+device.version+'&uuid='+device.uuid);

        // Restore da aplicação
        hideLoading();
      });
    } else {
        navigator.notification.alert('Você precisa ter o Instagram instalado para publicar sua foto!',function(){},'Outubro Rosa', 'OK');
        hideLoading();
    }
  });
};